#!/usr/bin/env python
# coding: utf-8

# In[1]:

import pandas as pd
import numpy as np
import matplotlib.pyplot as plt


# Read the data, divide them based on `error` value and group by `id` (id of task)

# In[2]:

src = pd.read_csv("spin_results.csv")
tasks_valid = src[src["error"] == 0].groupby("id")
tasks_error = src[src["error"] == 1].groupby("id")


# This function computes the ration of maximal value of `prop` among instances of the given task 

# In[14]:

def maxmin(task,prop):
    min = task[prop].min()
    max = task[prop].max()
    return max/min


# Check whether there are at least two instances for given task and then compute the ratios, store them into appropriete array

# In[15]:

valid_ar = []
for name,task in tasks_valid:
    if (task["id"].count() > 1):
        valid_ar.append([maxmin(task,"trans"),maxmin(task,"stored")])

        
error_ar = []
for name,task in tasks_error:
    if (task["id"].count() > 1):
        error_ar.append([maxmin(task,"trans"),maxmin(task,"stored")])


# In[5]:

maxmin_data_valid = pd.DataFrame(valid_ar,columns=["trans","stored"])
maxmin_data_error = pd.DataFrame(error_ar,columns=["trans","stored"])
maxmin_data_valid.to_csv("valid.dat",index=False)
maxmin_data_error.to_csv("error.dat",index=False)
